diff --git a/krita/ui/kis_selection_manager.cc b/krita/ui/kis_selection_manager.cc
index b3ec1c7..cf495a7 100644
--- a/krita/ui/kis_selection_manager.cc
+++ b/krita/ui/kis_selection_manager.cc
@@ -63,16 +63,14 @@
 #include "kis_paint_device.h"
 #include "kis_paint_layer.h"
 #include "kis_painter.h"
-#include "kis_selected_transaction.h"
-#include "kis_selection.h"
 #include "kis_transaction.h"
+#include "kis_selection.h"
 #include "kis_types.h"
 #include "kis_canvas_resource_provider.h"
 #include "kis_undo_adapter.h"
 #include "kis_pixel_selection.h"
 #include "flake/kis_shape_selection.h"
 #include "commands/kis_selection_commands.h"
-#include "kis_selection_transaction.h"
 #include "kis_selection_mask.h"
 #include "flake/kis_shape_layer.h"
 #include "kis_selection_decoration.h"
@@ -374,14 +372,14 @@ void KisSelectionManager::cut()
 
     copy();
 
-    KisSelectedTransaction *t = new KisSelectedTransaction(i18n("Cut"), layer);
-    Q_CHECK_PTR(t);
+    KisSelectedTransaction transaction(i18n("Cut"), layer);
 
     layer->paintDevice()->clearSelection(m_view->selection());
     QRect rect = m_view->selection()->selectedRect();
     deselect();
 
-    m_view->document()->addCommand(t);
+    transaction.commit(m_view->image()->undoAdapter());
+
     layer->setDirty(rect);
 }
 
@@ -507,7 +505,6 @@ void KisSelectionManager::pasteNew()
     if (!doc) return;
 
     Q_ASSERT(doc->undoAdapter() != 0);
-    doc->undoAdapter()->setUndo(false);
 
     KisImageWSP image = new KisImage(doc->undoAdapter(), r.width(), r.height(),
                                    KoColorSpaceRegistry::instance()->colorSpace(clip->colorSpace()->colorModelId().id(), clip->colorSpace()->colorDepthId().id(), clip->colorSpace()->profile()), "Pasted");    // TODO should be translated ?
@@ -521,8 +518,6 @@ void KisSelectionManager::pasteNew()
     image->addNode(layer.data(), image->rootLayer());
     doc->setCurrentImage(image);
 
-    doc->undoAdapter()->setUndo(true);
-
     KoMainWindow *win = new KoMainWindow(doc->componentData());
     win->show();
     win->setRootDocument(doc);
@@ -533,18 +528,25 @@ void KisSelectionManager::selectAll()
     KisImageWSP image = m_view->image();
     if (!image) return;
 
-    QUndoCommand* selectionCmd = new QUndoCommand(i18n("Select All"));
+    KisUndoAdapter *undoAdapter = m_view->image()->undoAdapter();
+    undoAdapter->beginMacro(i18n("Select All"));
 
-    if (!image->globalSelection())
-        new KisSetGlobalSelectionCommand(image, selectionCmd);
-    KisSelectionSP selection = image->globalSelection();
+    if (!image->globalSelection()) {
+        QUndoCommand *globalSelectionCommand =
+            new KisSetGlobalSelectionCommand(image, 0, 0);
 
-    new KisSelectionTransaction(QString(), image, selection, selectionCmd);
+        undoAdapter->addCommand(globalSelectionCommand);
+    }
+
+    KisSelectionSP selection = image->globalSelection();
 
+    KisSelectionTransaction transaction(QString(), image, selection);
     selection->getOrCreatePixelSelection()->select(image->bounds());
+    transaction.commit(undoAdapter);
+
+    undoAdapter->endMacro();
 
     m_view->selectionManager()->selectionChanged();
-    m_view->document()->addCommand(selectionCmd);
 }
 
 void KisSelectionManager::deselect()
@@ -575,7 +577,7 @@ void KisSelectionManager::clear()
 
     KisSelectionSP sel = m_view->selection();
 
-    KisTransaction * t = new KisTransaction(i18n("Clear"), dev);
+    KisTransaction transaction(i18n("Clear"), dev);
 
     if (sel)
         dev->clearSelection(sel);
@@ -584,8 +586,9 @@ void KisSelectionManager::clear()
         dev->setDirty();
     }
 
+    transaction.commit(image->undoAdapter());
+
     dev->setDirty(image->bounds());
-    image->undoAdapter()->addCommand(t);
 }
 
 void KisSelectionManager::deleteSelection()
@@ -620,15 +623,11 @@ void KisSelectionManager::fill(const KoColor& color, bool fillWithPattern, const
 
     KisPainter painter2(dev, selection);
 
-    if (image->undo()) painter2.beginTransaction(transactionText);
-
+    painter2.beginTransaction(transactionText);
     painter2.bitBlt(0, 0, filled, 0, 0, image->width(), image->height());
+    painter2.endTransaction(image->undoAdapter());
 
     dev->setDirty();
-
-    if (image->undo()) {
-        image->undoAdapter()->addCommand(painter2.endTransaction());
-    }
 }
 
 void KisSelectionManager::fillForegroundColor()
@@ -656,7 +655,7 @@ void KisSelectionManager::reselect()
 
     if (image->globalSelection()) {
         KisReselectGlobalSelectionCommand* cmd = new KisReselectGlobalSelectionCommand(image);
-        m_view->document()->addCommand(cmd);
+        image->undoAdapter()->addCommand(cmd);
     }
 }
 
@@ -669,16 +668,14 @@ void KisSelectionManager::invert()
     KisSelectionSP selection = m_view->selection();
     if (!selection) return;
 
-    KisPixelSelectionSP s = selection->getOrCreatePixelSelection();
-
-    KisSelectionTransaction * t = new KisSelectionTransaction(i18n("Invert"), image, selection);
-    Q_CHECK_PTR(t);
+    KisPixelSelectionSP pixelSelection = selection->getOrCreatePixelSelection();
 
-    s->invert();
-    s->setDirty(image->bounds());
+    KisSelectionTransaction transaction(i18n("Invert"), image, selection);
+    pixelSelection->invert();
+    transaction.commit(image->undoAdapter());
 
+    pixelSelection->setDirty(image->bounds());
     selectionChanged();
-    m_view->document()->addCommand(t);
 }
 
 void KisSelectionManager::copySelectionToNewLayer()
@@ -741,7 +738,7 @@ void KisSelectionManager::grow(qint32 xradius, qint32 yradius)
     if (xradius <= 0 || yradius <= 0)
         return;
 
-    KisSelectionTransaction *t = new KisSelectionTransaction(i18n("Grow Selection"), image, m_view->selection());
+    KisSelectionTransaction transaction(i18n("Grow Selection"), image, m_view->selection());
 
     max = new quint8* [layerSize.width() + 2 * xradius];
     buf = new quint8* [yradius + 1];
@@ -839,7 +836,8 @@ void KisSelectionManager::grow(qint32 xradius, qint32 yradius)
     delete[] buf;
     delete[] out;
 
-    m_view->document()->addCommand(t);
+    transaction.commit(image->undoAdapter());
+
     m_view->selection()->setDirty(image->bounds());
     selectionChanged();
 }
@@ -853,8 +851,7 @@ void KisSelectionManager::shrink(qint32 xradius, qint32 yradius, bool edge_lock)
     if (!m_view->selection()) return;
     KisPixelSelectionSP selection = m_view->selection()->getOrCreatePixelSelection();
 
-    KisSelectionTransaction *t = new KisSelectionTransaction(i18n("Shrink Selection"), image, m_view->selection());
-    Q_CHECK_PTR(t);
+    KisSelectionTransaction transaction(i18n("Shrink Selection"), image, m_view->selection());
 
     //determine the layerSize
     QRect layerSize = image->bounds();
@@ -989,7 +986,8 @@ void KisSelectionManager::shrink(qint32 xradius, qint32 yradius, bool edge_lock)
     delete[] buf;
     delete[] out;
 
-    m_view->document()->addCommand(t);
+    transaction.commit(image->undoAdapter());
+
     m_view->selection()->setDirty(image->bounds());
     selectionChanged();
 }
@@ -1202,8 +1200,7 @@ void KisSelectionManager::border(qint32 xradius, qint32 yradius)
     //determine the layerSize
     QRect layerSize = image->bounds();
 
-    KisSelectionTransaction *t = new KisSelectionTransaction(i18n("Border Selection"), image, m_view->selection());
-    Q_CHECK_PTR(t);
+    KisSelectionTransaction transaction(i18n("Border Selection"), image, m_view->selection());
 
     quint8  *buf[3];
     quint8 **density;
@@ -1241,7 +1238,8 @@ void KisSelectionManager::border(qint32 xradius, qint32 yradius)
             delete[] source[i];
         delete[] transition;
 
-        m_view->document()->addCommand(t);
+        transaction.commit(image->undoAdapter());
+
         m_view->selection()->setDirty(image->bounds());
         selectionChanged();
         return;
@@ -1406,8 +1404,8 @@ void KisSelectionManager::border(qint32 xradius, qint32 yradius)
     density -= xradius;
     delete[] density;
 
+    transaction.commit(image->undoAdapter());
 
-    m_view->document()->addCommand(t);
     m_view->selection()->setDirty(image->bounds());
     selectionChanged();
 }
@@ -1420,8 +1418,7 @@ void KisSelectionManager::feather(qint32 radius)
         return;
 
     KisPixelSelectionSP selection = m_view->selection()->getOrCreatePixelSelection();
-    KisSelectionTransaction * t = new KisSelectionTransaction(i18n("Feather Selection"), image, m_view->selection());
-    Q_CHECK_PTR(t);
+    KisSelectionTransaction transaction(i18n("Feather Selection"), image, m_view->selection());
 
     // compute horizontal kernel
     const uint kernelSize = radius * 2 + 1;
@@ -1455,7 +1452,8 @@ void KisSelectionManager::feather(qint32 radius)
     verticalPainter.applyMatrix(kernelVertical, interm, rect.topLeft(), rect.topLeft(), rect.size(), BORDER_AVOID);
     verticalPainter.end();
 
-    m_view->document()->addCommand(t);
+    transaction.commit(image->undoAdapter());
+
     m_view->selection()->setDirty(image->bounds());
     selectionChanged();
 }
diff --git a/krita/ui/kis_view2.cpp b/krita/ui/kis_view2.cpp
index c310d70..85c8f34 100644
--- a/krita/ui/kis_view2.cpp
+++ b/krita/ui/kis_view2.cpp
@@ -620,7 +620,7 @@ void KisView2::connectCurrentImage()
     if (image()) {
         if (m_d->statusBar) {
             connect(image(), SIGNAL(sigColorSpaceChanged(const KoColorSpace *)), m_d->statusBar, SLOT(updateStatusBarProfileLabel()));
-            connect(image(), SIGNAL(sigProfileChanged(KoColorProfile *)), m_d->statusBar, SLOT(updateStatusBarProfileLabel()));
+            connect(image(), SIGNAL(sigProfileChanged(const KoColorProfile *)), m_d->statusBar, SLOT(updateStatusBarProfileLabel()));
             connect(image(), SIGNAL(sigSizeChanged(qint32, qint32)), m_d->statusBar, SLOT(imageSizeChanged(qint32, qint32)));
 
         }
diff --git a/krita/ui/kra/kis_kra_loader.cpp b/krita/ui/kra/kis_kra_loader.cpp
index 2f1085c..372a687 100644
--- a/krita/ui/kra/kis_kra_loader.cpp
+++ b/krita/ui/kra/kis_kra_loader.cpp
@@ -201,7 +201,7 @@ void KisKraLoader::loadBinaryData(KoStore * store, KisImageWSP image, const QStr
         QByteArray data; data.resize(store->size());
         store->read(data.data(), store->size());
         store->close();
-        image->setProfile(KoColorSpaceRegistry::instance()->createColorProfile(image->colorSpace()->colorModelId().id(), image->colorSpace()->colorDepthId().id(), data));
+        image->assignImageProfile(KoColorSpaceRegistry::instance()->createColorProfile(image->colorSpace()->colorModelId().id(), image->colorSpace()->colorDepthId().id(), data));
     }
 
 
diff --git a/krita/ui/tool/kis_selection_tool_helper.cpp b/krita/ui/tool/kis_selection_tool_helper.cpp
index 2920fd5..7d6eca4 100644
--- a/krita/ui/tool/kis_selection_tool_helper.cpp
+++ b/krita/ui/tool/kis_selection_tool_helper.cpp
@@ -31,7 +31,7 @@
 #include "canvas/kis_canvas2.h"
 #include "kis_view2.h"
 #include "kis_selection_manager.h"
-#include "kis_selection_transaction.h"
+#include "kis_transaction.h"
 #include "commands/kis_selection_commands.h"
 #include "kis_shape_controller.h"
 
@@ -52,52 +52,52 @@ KisSelectionToolHelper::~KisSelectionToolHelper()
 {
 }
 
-QUndoCommand* KisSelectionToolHelper::selectPixelSelection(KisPixelSelectionSP selection, selectionAction action)
+void KisSelectionToolHelper::selectPixelSelection(KisPixelSelectionSP selection, selectionAction action)
 {
-    bool hasSelection = m_layer->selection();
+    KisUndoAdapter *undoAdapter = m_layer->image()->undoAdapter();
+    undoAdapter->beginMacro(m_name);
 
-    QUndoCommand* selectionCmd = new QUndoCommand(m_name);
+    bool hasSelection = m_layer->selection();
 
     if (!hasSelection)
-        new KisSetGlobalSelectionCommand(m_image, selectionCmd);
+        undoAdapter->addCommand(new KisSetGlobalSelectionCommand(m_image));
 
-    new KisSelectionTransaction(m_name, m_image, m_layer->selection(), selectionCmd);
+    KisSelectionTransaction transaction(m_name, m_image, m_layer->selection());
 
-    KisPixelSelectionSP getOrCreatePixelSelection = m_layer->selection()->getOrCreatePixelSelection();
+    KisPixelSelectionSP pixelSelection = m_layer->selection()->getOrCreatePixelSelection();
 
     if (! hasSelection || action == SELECTION_REPLACE) {
-        getOrCreatePixelSelection->clear();
+        pixelSelection->clear();
         if (action == SELECTION_SUBTRACT)
-            getOrCreatePixelSelection->invert();
+            pixelSelection->invert();
     }
-    getOrCreatePixelSelection->applySelection(selection, action);
+    pixelSelection->applySelection(selection, action);
 
+    QRect dirtyRect = m_image->bounds();
     if (hasSelection && action != SELECTION_REPLACE && action != SELECTION_INTERSECT) {
-        QRect rc = selection->selectedRect();
-        getOrCreatePixelSelection->setDirty(rc);
-        m_layer->selection()->updateProjection(rc);
-        m_canvas->view()->selectionManager()->selectionChanged();
-    } else {
-        getOrCreatePixelSelection->setDirty(m_image->bounds());
-        m_layer->selection()->updateProjection(m_image->bounds());
-        m_canvas->view()->selectionManager()->selectionChanged();
+        dirtyRect = selection->selectedRect();
     }
-    return selectionCmd;
+    m_layer->selection()->updateProjection(dirtyRect);
+
+    transaction.commit(undoAdapter);
+    undoAdapter->endMacro();
+
+    pixelSelection->setDirty(dirtyRect);
+    m_canvas->view()->selectionManager()->selectionChanged();
 }
 
 void KisSelectionToolHelper::addSelectionShape(KoShape* shape)
 {
-    bool hasSelection = m_layer->selection();
+    KisUndoAdapter *undoAdapter = m_layer->image()->undoAdapter();
+    undoAdapter->beginMacro(m_name);
 
-    m_canvas->startMacro(m_name);
+    bool hasSelection = m_layer->selection();
 
     if (!hasSelection)
-        m_canvas->addCommand(new KisSetGlobalSelectionCommand(m_image, 0));
+        undoAdapter->addCommand(new KisSetGlobalSelectionCommand(m_image, 0));
 
     KisSelectionSP selection = m_layer->selection();
-
-    if (selection->isDeselected())
-        new KisSelectionTransaction(m_name, m_image, m_layer->selection());
+    KisSelectionTransaction transaction(m_name, m_image, m_layer->selection());
 
     KisShapeSelection* shapeSelection;
     if (!selection->hasShapeSelection()) {
@@ -111,9 +111,10 @@ void KisSelectionToolHelper::addSelectionShape(KoShape* shape)
     if (kiscontroller)
         kiscontroller->prepareAddingSelectionShape();
 
-    QUndoCommand * cmd = m_canvas->shapeController()->addShape(shape);
-    m_canvas->addCommand(cmd);
+    transaction.commit(undoAdapter);
 
-    m_canvas->stopMacro();
+    QUndoCommand *cmd = m_canvas->shapeController()->addShape(shape);
+    undoAdapter->addCommand(cmd);
+    undoAdapter->endMacro();
 }
 
diff --git a/krita/ui/tool/kis_selection_tool_helper.h b/krita/ui/tool/kis_selection_tool_helper.h
index 21e671e..5a29863 100644
--- a/krita/ui/tool/kis_selection_tool_helper.h
+++ b/krita/ui/tool/kis_selection_tool_helper.h
@@ -37,7 +37,7 @@ public:
     KisSelectionToolHelper(KisCanvas2* canvas, KisNodeSP node, const QString& name);
     virtual ~KisSelectionToolHelper();
 
-    QUndoCommand* selectPixelSelection(KisPixelSelectionSP selection, selectionAction action);
+    void selectPixelSelection(KisPixelSelectionSP selection, selectionAction action);
     void addSelectionShape(KoShape* shape);
 
 private:
diff --git a/krita/ui/tool/kis_tool_freehand.cc b/krita/ui/tool/kis_tool_freehand.cc
index 4180544..88dabb0 100644
--- a/krita/ui/tool/kis_tool_freehand.cc
+++ b/krita/ui/tool/kis_tool_freehand.cc
@@ -450,8 +450,7 @@ void KisToolFreehand::endPaint()
         KisLayerSP layer = dynamic_cast<KisLayer*>(currentNode().data());
 
         if (layer && !m_paintIncremental) {
-            KisTransaction *incrementalTransaction =
-                    dynamic_cast<KisTransaction*>(m_painter->endTransaction());
+            m_painter->deleteTransaction();
 
             KisPainter painter(m_source, currentSelection());
             painter.setCompositeOp(m_compositeOp);
@@ -475,12 +474,12 @@ void KisToolFreehand::endPaint()
                 indirect->setTemporaryTarget(0);
             }
             m_source->setDirty(painter.dirtyRegion());
-            delete incrementalTransaction;
 
             m_incrementalDirtyRegion = QRegion();
-            canvas()->addCommand(painter.endTransaction());
+
+            painter.endTransaction(image()->undoAdapter());
         } else {
-            canvas()->addCommand(m_painter->endTransaction());
+            m_painter->endTransaction(image()->undoAdapter());
         }
     }
     delete m_painter;
diff --git a/krita/ui/widgets/kis_custom_image_widget.cc b/krita/ui/widgets/kis_custom_image_widget.cc
index 21309af..f976bb0 100644
--- a/krita/ui/widgets/kis_custom_image_widget.cc
+++ b/krita/ui/widgets/kis_custom_image_widget.cc
@@ -193,9 +193,10 @@ void KisCustomImageWidget::buttonClicked()
         if (layer && backgroundOpacity() < OPACITY_OPAQUE_U8) {
             KisFillPainter painter;
             painter.begin(layer->paintDevice());
+#warning "Why transaction here? FIXME: remove it!"
             painter.beginTransaction("");
             painter.fillRect(0, 0, width, height, bgColor, OPACITY_OPAQUE_U8);
-            delete painter.endTransaction();
+            painter.deleteTransaction();
 
         }
         if (chkFromClipboard->isChecked()) {
